import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'attestr_flowx_plugin_platform_interface.dart';

/// An implementation of [AttestrFlowxPluginPlatform] that uses method channels.
class MethodChannelAttestrFlowxPlugin extends AttestrFlowxPluginPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('attestr_flowx_plugin');

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }

}
