import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'attestr_flowx_plugin_method_channel.dart';

abstract class AttestrFlowxPluginPlatform extends PlatformInterface {
  /// Constructs a AttestrFlowxPluginPlatform.
  AttestrFlowxPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static AttestrFlowxPluginPlatform _instance = MethodChannelAttestrFlowxPlugin();

  /// The default instance of [AttestrFlowxPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelAttestrFlowxPlugin].
  static AttestrFlowxPluginPlatform get instance => _instance;
  
  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [AttestrFlowxPluginPlatform] when
  /// they register themselves.
  static set instance(AttestrFlowxPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
