import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:attestr_flowx_plugin/attestr_flowx_plugin_method_channel.dart';

void main() {
  MethodChannelAttestrFlowxPlugin platform = MethodChannelAttestrFlowxPlugin();
  const MethodChannel channel = MethodChannel('attestr_flowx_plugin');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await platform.getPlatformVersion(), '42');
  });
}
